package com.adventurer_engine.client.model.tmt;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import atc;
import com.adventurer_engine.client.model.tmt.PositionTextureVertex;
import com.adventurer_engine.client.model.tmt.TransformGroup;
import java.util.ArrayList;

public class PositionTransformVertex extends PositionTextureVertex {
  public atc neutralVector;
  
  public ArrayList<TransformGroup> transformGroups;
  
  public PositionTransformVertex(float x, float y, float z, float u, float v) {
    this(atc.a(x, y, z), u, v);
  }
  
  public PositionTransformVertex(PositionTextureVertex vertex, float u, float v) {
    super(vertex, u, v);
    this.transformGroups = new ArrayList<TransformGroup>();
    if (vertex instanceof com.adventurer_engine.client.model.tmt.PositionTransformVertex) {
      this.neutralVector = ((com.adventurer_engine.client.model.tmt.PositionTransformVertex)vertex).neutralVector;
    } else {
      this.neutralVector = atc.a(vertex.a.c, vertex.a.d, vertex.a.e);
    } 
  }
  
  public PositionTransformVertex(PositionTextureVertex vertex) {
    this(vertex, vertex.b, vertex.c);
  }
  
  public PositionTransformVertex(atc vector, float u, float v) {
    super(vector, u, v);
    this.transformGroups = new ArrayList<TransformGroup>();
    this.neutralVector = atc.a(vector.c, vector.d, vector.e);
  }
  
  public void setTransformation() {
    if (this.transformGroups.size() == 0) {
      this.a.c = this.neutralVector.c;
      this.a.d = this.neutralVector.d;
      this.a.e = this.neutralVector.e;
      return;
    } 
    double weight = 0.0D;
    int i;
    for (i = 0; i < this.transformGroups.size(); i++)
      weight += ((TransformGroup)this.transformGroups.get(i)).getWeight(); 
    this.a.c = 0.0D;
    this.a.d = 0.0D;
    this.a.e = 0.0D;
    for (i = 0; i < this.transformGroups.size(); i++) {
      TransformGroup group = this.transformGroups.get(i);
      double cWeight = group.getWeight() / weight;
      atc vector = group.doTransformation(this);
      this.a.c += cWeight * vector.c;
      this.a.d += cWeight * vector.d;
      this.a.e += cWeight * vector.e;
    } 
  }
  
  public void addGroup(TransformGroup group) {
    this.transformGroups.add(group);
  }
  
  public void removeGroup(TransformGroup group) {
    this.transformGroups.remove(group);
  }
}
